<disease-details class=details>

  <header class=row>
    <div>
      <div class="avatar">
        <icon figure=placeholder-disease />
      </div>
    </div>

    <div>
      <h1><disease-gauge depth={ this.opts.disease.depth } max-depth={ this.opts.disease.max_depth } /> { this.opts.disease.label }</h1>
      <p>
        Orphanet: <a href="https://www.orpha.net/consor/cgi-bin/OC_Exp.php?Expert={ this.opts.disease.pk }" title="View on Orphanet" target=_blank>{ this.opts.disease.pk }</a></span>
      </p>
    </div>
  </header>

  <section>
    <ul>
      <li class=grouping if={ this.opts.disease.groupings.length }>
        <grouping-tag each={ grouping in this.opts.disease.groupings } value={ grouping.name } />
      </li>
      <li>Classification level:&nbsp;<span> { this.groupOfType } ({ this.opts.disease.disorder_type }) </span></li>
      <li><icon figure=gauge-1 /> Classification:
        <ul>
          <li each={ root_ in this.opts.disease.roots }>
            <tag type=disease label="{ root_.name }" external-url="https://www.orpha.net/consor/cgi-bin/OC_Exp.php?Expert={ root_.pk }" external-title="View details on Orphanet" value={ root_.pk }  details-link=/disease/{ root_.pk } />
          </div>
          </li>
        </ul>
      </li>
      <li if={ this.opts.disease.synonyms }><icon figure=synonyms />Synonyms:&nbsp;<span> { this.opts.disease.synonyms.join(', ') } </span></li>
    </ul>
  </section>

  <section>
    <fieldset>
      <h3>Manage Groupings</h3>
      <form onsubmit={this.saveGroupings}>
        <table>
          <thead>
            <tr>
              <th>Assigned</th>
              <th>Validated</th>
              <th>Name</th>
            </tr>
          </thead>
          <tbody>
              <tr each={ grouping in this.configGroupings }>
                <td>
                  <input type=checkbox name=grouping checked={ this.hasGrouping(grouping.key) } value={ grouping.key } id="grouping_{grouping.key}" onchange={ this.addGrouping }>
                  <label for="grouping_{grouping.key}"></label>
                </td>
                <td>
                  <input type=checkbox name=grouping_validate value={ grouping.key } checked={ this.isValidated(grouping.key) } id="grouping_validate_{grouping.key}" disabled={ !this.hasGrouping(grouping.key) }>
                  <label for="grouping_validate_{grouping.key}"></label>
                </td>
                <td>
                  {grouping.value} <small>– {grouping.key}</small>
                </td>
              </tr>
            </span>
          </tbody>
        </table>
        <button class="primary row">Save</button>
      </form>
    </fieldset>
  </section>

  <diffs if={ this.opts.diffs } diffs={ this.opts.diffs } />

  <section class=toolbar>
    <small>
      <a href="{ '/disease/' + this.opts.disease.pk + '/history' }">Blame who messed with this</a>
    </small>
  </section>

  <script>
    this.on('mount', () => {
      this.groupOfType = config.DISEASE_GROUP_OF_TYPES[this.opts.disease.group_of_type]
      this.configGroupings = config.GROUPING.sort((a, b) => a.value < b.value ? -1 : 1)
      this.update()
    })

    this.hasGrouping = (name) => {
      return !!this.opts.disease.groupings.find(g => g.name === name)
    }

    this.isValidated = (name) => {
      return !!this.opts.disease.groupings.find(g => g.name === name)?.validated
    }

    this.addGrouping = (event) => {
      const groupingValidate = this.root.querySelector(`#grouping_validate_${event.target.value}`)

      if (event.target.checked)
        groupingValidate.disabled = false;
      else {
        groupingValidate.checked = false;
        groupingValidate.disabled = true;
        this.opts.disease.groupings = this.opts.disease.groupings.filter(g => g.name !== event.target.value);
      }
    }

    this.saveGroupings = async (event) => {
      event.preventDefault()
      const data = new FormData(event.target)
      const groupingValidates = data.getAll('grouping_validate')
      const updateGroupings = data.getAll('grouping').reduce((acc, name) => {
        return [...acc, {name, validated: !!groupingValidates.includes(name)}]
      }, [])
      const response = apiResponse(await api(`/disease/${this.opts.disease.pk}`, { method: 'patch', data: { groupings: updateGroupings } }))
      if (response.ok) {
        page(`/disease/${this.opts.disease.pk}`)
        notify(`Groupings were saved successfully`, 'success')
      }
    }
  </script>

  <link rel="stylesheet" href="/src/css/details.css">
  <style>
    h1,
    header a,
    header a:hover {
      color: var(--disease);
    }
    .row {
      margin-top: 0;
      margin-bottom: 1.6rem;
    }
    h1 + p {
      margin: 0;
    }
    header a {
      text-decoration: underline;
    }
    header a:hover {
      background: none;
    }

    section {
      font-weight: 500;
    }

    section:not(.toolbar):before {
      background-color: transparent !important;
    }

    ul ul {
      flex-basis: 100%;
      margin-top: 0.4rem !important;
      margin-left: 1.4rem !important;
    }
    li {
      flex-wrap: wrap;
      font-weight: 500;
    }
    li span {
      font-weight: normal;
    }

    form button {
      margin-top: 1rem !important;
    }

    th {
      padding-right: 3rem;
      text-align: left;
    }
    td label::before {
      top: -8px !important;
    }
    td label::after {
      top: -7px !important;
    }
  </style>
</disease-details>
